<template>
  <div class="wrapper">
    <header class="business-header">
      <div class="container">
        <div class="row">
          <div class="col-lg-12">
            <h1 class="display-3 text-center text-white mt-4">{{ result.name }}</h1>
          </div>
        </div>
      </div>
    </header>
    <div class="container">
      <div class="row">
        <div class="col-sm-8">
          <div class="mt-3">
            <p> Status da Central: {{ central_status }} </p>
          </div>
          <h2 class="mt-4">Informações da Central</h2>
          <p>{{ result.presentation }}</p>
          <hr>
          <p>{{ result.english_presentation }}</p>
          <div v-if="president" class="my-3">
            <h4 class="mt-4">Responsabilidade Gerencial</h4>
            <div class="font-weight-heavy">Presidente da Central:</div>
            <div class="font-weight-light">{{ president.user_name }}</div>
            <div class="font-weight-heavy">E-mail:</div>
            <div class="font-weight-light"> {{ president.user_email }}</div>
          </div>
          <hr>
          <div>
            <h4>Serviços</h4>
            <div class="font-weight-light">{{ result.services }}</div>
            <br>
            <div class="font-weight-light">{{ result.observations }}</div>
            <br>
            <h4>Horarios de atendimento:</h4>
            <div class="font-weight-light">{{ result.attendance_hours }}</div>
          </div>
        </div>
        <div class="col-sm-4">
          <h2 class="mt-4">Contato-nos</h2>
          <address>
            <strong>{{ result.name }}</strong>
            <br>{{ result.address }}
            <br>{{ result.city + " - " + result.state }}
            <br>{{ result.postal_code }}
            <br>{{ result.site }}
            <br>
          </address>
          <address>
            Telefones:
            <br>
            {{ result.phone_1 }}
            <br>
            {{ result.phone_2 }}
            <br>
            <br>
            Email: 
            <a>{{ result.email }}</a>
          </address>
        </div>
      </div>
    </div>

    <b-card class="my-3">
      <div class="pt-3 titles-container">
        <p class="form-title text-center font-weight-bold">
          Equipamentos da central
        </p>
        <div v-if="equipment_search_size > 0">
          <div v-for="search_response in search_responses" :key="search_response.equipment_name" class="card">
            <b-card @click="onClickEquipment(search_response.id)">
              <p><b>{{ search_response.equipment_name }}</b></p>
              <p>{{ search_response.presentation }}</p>
            </b-card>
          </div>
        </div>
        <div v-else><h4>Nenhum equipamento cadastrado</h4>
        </div>

        
        <div v-if="isPresident">
          <add-equipment/>
        </div>
      </div>
    </b-card>
    <div v-if="isPresident">
      <b-card class="my-3">
        <add-manager/>
      </b-card>
    </div>
  </div>
</template>

<script>
import AddEquipment from "~/components/Central/AddEquipment.vue";
import AddManager from "~/components/Central/AddManager.vue";

export default {
  components: {
    AddEquipment,
    AddManager
  },
  data() {
    return {
      isPresident: null,
      president: null,
      equipments_search: {
        search_term: "",
        central_name: true
      },
      result: {},
      search_responses: []
    };
  },
  computed: {
    equipment_search_size: function() {
      return this.search_responses.length;
    },
    central_status: function() {
      if (this.result.approved) {
        return "Aprovada";
      } else if (this.result.pending) {
        return "Pendente";
      } else if (this.search_responses.length === 0) {
        return "Inativa. Cadastre ao menos um equipamento para oficializar o cadastro da Central";
      } else {
        return "Reprovadas";
      }
    }
  },
  beforeCreate: async function() {
    try {
      const response = await this.$axios.$get(
        "central/" + this.$route.params.id
      );
      this.result = response; // gets the central info
      this.equipments_search.search_term = response.name;
      const equipments_response = await this.$axios.$post(
        "search/equipments",
        this.equipments_search
      );
      this.search_responses = equipments_response.equipments; // get the equip. info
      const president = await this.$axios.$get(
        `user/${this.$route.params.id}/president`
      ); // gets the president and see if the user is president
      this.president = president;
      this.isPresident =
        parseInt(this.$store.getters.getUser.id) === president.id;
    } catch (e) {
      console.log(e);
    }
  },
  methods: {
    onClickEquipment(id) {
      this.$router.push("/equipamento/" + id);
    },
    redirect_to_equipment() {
      this.$router.push(
        "/cadastro/equipamento?central_id=" + this.$route.params.id
      );
    }
  }
};
</script>

<style>
.business-header {
  height: 50vh;
  min-height: 300px;
  background: url("../assets/microscope.jpeg") center center no-repeat scroll;
  -webkit-background-size: cover;
  -moz-background-size: cover;
  background-size: cover;
  -o-background-size: cover;
}

body {
  padding-top: 54px;
}

@media (min-width: 992px) {
  body {
    padding-top: 56px;
  }
}

.card {
  height: 100%;
}
</style>
